<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2008 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.3.14x - Last modified 7/12/2008
*/


/*
NOTES:
	if (image_jpeg == true):
	Compress level of 1-2 is archival, 4 starts showing artifacts.  3-4 recommended.  0 not recommended due to lossless JPEG (use PNG instead).  Anything over 10 not recommended except for thumbnails.  Max value may be 100 if you hate your artists.  :)

	if (image_jpeg == false):
	PaintBBS employs lossy PNG!  Level should be 0 if image_jpeg is false.  PaintBBS doesn't murder PNGs like ShiPainter, but still, lossy PNG is not pretty.

	if (new pic) {
		Send nothing to comment.php.
	} elseif (public edit by new artist) {
		Send import to comment.php.
	} else {
		send edit and import.
	}
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');
require ('paintsave.php');

// Input
$xcord = w_gpc('xcord', 'i');
$ycord = w_gpc('ycord', 'i');
$anim  = w_gpc('anim', 'i');
$edit  = w_gpc('edit', 'i+');
$user_pass = w_gpc('pw'); // Encoded with make_edit_pass()

// Init
$app_head     = ''; // Passed to save tool
$app_head_pw  = ''; // Added to $app_head
$app_url_exit = ''; // Params for index (comment)
$import       = ''; // Canvas number to import.  Passed to save tool
$app_import   = ''; // Canvas/anim filename to import (based on $anim)
$anim_type    = 'pch'; // Extension for animation


// Check Draw access
if (!$flags['D']) {
	report_err($langop_err_drawaccess);
}

// Check anim access
// If retouch, anim flag is ignored
if (!$flags['M']) {
	$anim = 0;
}


if ($edit) {
	// Get pic info
	$result = mysql_query ("SELECT PIC_ID, usrname, animation, password, ptype FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$edit'");
	$row = mysql_fetch_array ($result);

	// Verify anim
	if ($row['animation'] == 1) {
		$anim = 1;
	} else {
		$anim = 0;
	}

	// Set up import
	$import = $edit;
	if ($anim) {
		$app_import = $p_pic.$import.'.'.$anim_type;
	} else {
		$app_import = $p_pic.$import.'.'.$row['ptype'];
	}

	// Choose pass/public retouch option
	if ($row['usrname'] != $OekakiU) {
		$enc_pass = make_edit_pass($row['password']);
		if ($enc_pass == $user_pass) {
			// Password retouch
			// Due to technical/admin issues, only in-place edits are supported
			$app_head_pw = $enc_pass;
		} elseif ($row['password'] == 'public') {
			if ($cfg['public_retouch'] == 'yes') {
				// Public, treat as new pic, but import canvas/anim
				unset ($edit);
			} else {
				// pw != public, and public disabled
				report_err($langop_pubretouchdis);
			}
		} else {
			// Invalid!
			report_err($langop_errrtpwd);
		}
	}
	$size = GetImageSize ($p_pic.$row['PIC_ID'].'.'.$row['ptype']);
	$xcord = $size[0];
	$ycord = $size[1];
} else {
	// Check for unfinished pictures
	$result = mysql_query ("SELECT COUNT(PIC_ID) FROM {$OekakiPoteto_Prefix}oekakidta WHERE postlock=0 AND usrname='$OekakiU'");
	$num_rows = (int) mysql_result ($result, 0);

	if (defined ('ALLOW_ADDITIONAL_WIPS') && ALLOW_ADDITIONAL_WIPS > 0) {
		if ($num_rows > ALLOW_ADDITIONAL_WIPS) {
			report_err($langop_munfinishpic);
		}
	} else {
		if ($num_rows > 0) {
			report_err($langop_aunfinishpic);
		}
	}
}


// Recolor
if (empty ($edit) && empty ($import)) {
	// Name, such as "pic.png"
	$recolor = w_gpc('recolor');

	if (!empty ($recolor)) {
		// Clean, add path
		$file_illegal = array ('"', '?', '*', '/', '\\', ':', '|', '<', '>');
		$app_import = './recolor/'.str_replace ($file_illegal, '', $recolor);

		if (file_exists ($app_import)) {
			$size = @GetImageSize ($app_import);
			$xcord = $size[0];
			$ycord = $size[1];
		} else {
			// Recolor used as import flag
			$recolor = '';
			$app_import = '';
			$xcord = $cfg['canvas_x'];
			$ycord = $cfg['canvas_y'];
		}
	}
}


// Verify that canvas sizes fit min/max
$xcord = fix_range($cfg['min_x'], $cfg['canvas_x'], $xcord);
$ycord = fix_range($cfg['min_y'], $cfg['canvas_y'], $ycord);


// Set applet area
{
	/* A bug in the Mac version of Java 1.5 requires hard-coded values, rather than CSS.  So, we set to a reasonable default, and grow the applet to fit the canvas. */

	// Typical viewable width of 800x600 browser is 740px.
	$xhack = 600; // Applet x (plus NoteBBS sidebar)
	$yhack = 550; // Applet y
	$xoverhead = 100 ; // Applet border/palette width
	$yoverhead = 35;

	if (DISABLE_APPLET_AREA_HACK) {
		$xhack = '100%';
		// $yhack = '90%'; // HTML quirks mode only
	} else {
		if ($xcord > ($xhack - $xoverhead))
			$xhack = $xcord + $xoverhead;
	}
	if ($ycord > ($yhack - $yoverhead))
		$yhack = $ycord + $yoverhead;
}


// Get filesize cutoff.  See notes above about compress_level
// APPLET_NO_JPEG is in hacks.php
$image_jpeg_value = (APPLET_NO_JPEG != 0) ? 'false' : 'true';
$image_compress = (APPLET_NO_JPEG != 0) ? '0' : '4';
$image_size_value = applet_image_size_param($xcord, $ycord);


// Set up applet header
if ($edit) {
	$app_head_mode = 'edit';
} elseif ($anim) {
	$app_head_mode = 'anim';
} else {
	$app_head_mode = 'norm';
}

$app_head = "mode={$app_head_mode};edittimes=".time().";usr={$OekakiU};vcode=".$OekakiPass;
if ($edit) {
	$app_head .= ";edit={$edit}";
}
if ($import) {
	$app_head .= ";import={$import}";
}
if (!empty ($app_head_pw)) {
	$app_head .= ';pw='.$app_head_pw;
}

// Set up applet exit
$app_url_exit = 'comment.php?mode=res_msg';
if ($import && !$edit) {
	$app_url_exit .= "&import={$import}";
} elseif ($import) {
	$app_url_exit .= "&import={$import}&edit={$edit}";
}
if (!empty ($app_head_pw)) {
	$app_url_exit .= '&pw='.$app_head_pw;
}


// No footer
mysql_close ($dbconn);



// Start HTML
send_html_headers();
?>
<head>
	<meta http-equiv="content-type" content="text/html; charset=<?=$charset?>" />
	<meta http-equiv="content-language" content="<?=$metatag_language?>" />

	<title><?=$cfg['op_title']?></title>

	<link rel="stylesheet" type="text/css" href="<?=$cssinclude?>" title="<?=$template_name?>" />

	<script type="text/javascript" src="Poteto.js">
	</script>
	<script type="text/javascript" src="noteBBS.js">
	</script>
</head>

<body>


<table style="width: 100%; padding: 0;" cellspacing="0">
<tr>
<td style="width: 80%; text-align: center; vertical-align: top;">

	<applet id="paintbbs"
		code="pbbs.PaintBBS.class"
		archive="PaintBBS.jar"
		width="<?=$xhack;?>"
		height="<?=$yhack;?>">

		<param name="image_width" value="<?=$xcord;?>" />
		<param name="image_height" value="<?=$ycord;?>" />

		<param name="image_jpeg" value="<?=$image_jpeg_value;?>" />
		<param name="image_size" value="<?=$image_size_value;?>" />
		<param name="compress_level" value="<?=$image_compress;?>" />

<? if ($import || $recolor) { ?>
		<param name="image_canvas" value="<?=$app_import;?>" />
<? } ?>
<? if ($anim) { ?>
		<param name="thumbnail_type" value="animation" />
<? } ?>
		<param name="url_save" value="paintbbsget.php" />
		<param name="url_exit" value="<?=w_html_chars($app_url_exit);?>" />
		<param name="url_target" value="_self" />

		<param name="undo" value="60" />
		<param name="undo_in_mg" value="12" />

		<param name="poo" value="false" />
		<param name="send_header" value="<?=w_html_chars($app_head);?>" />
		<param name="send_header_image_type" value="false" />

		<param name="image_bkcolor" value="#ffffff" />
		<param name="color_text" value="#505078" />
		<param name="color_bk" value="#9999bb" />
		<param name="color_bk2" value="#8888aa" />
		<param name="color_icon" value="#ccccff" />

		<param name="tool_advance" value="true" />
		<param name="send_advance" value="true" />
		<param name="send_language" value="utf8" />

		You need Java&trade; to run this applet.  <a href="http://www.java.com">Click here to download Java</a>.
	</applet>


	<p>
		<input onclick="maximize_app('paintbbs');" type="button" value="<?=$langop_resizeapplet?>" class="submit" />
	</p>


	<p style="text-align: center;">
		<input onclick="size_app('paintbbs');" type="button" value="<?=$langop_resize_to_this;?>" class="submit" />
		X:<input id="button_x" type="text" size="3" value="<?=$xhack?>" class="txtinput" />
		Y:<input id="button_y" type="text" size="3" value="<?=$yhack?>" class="txtinput" />
	</p>
</td>

<td style="text-align: right; vertical-align: top; padding-right: 10px;">
	<form name="Palette" action="post">
		<h4><?=$langop_word_Palette?></h4>

		<p>
			<input onclick="PaletteSave()" type="button" value="<?=$langop_setdefpalette?>" name="button2" class="submit" />
			<br />
		</p>

		<p>
			<select onchange="setPalette()" name="select" size="15" class="pmultiline">
				<option selected="selected"><?=$langop_word_default?></option>
				<option><?=$langop_pallette1?></option>
				<option><?=$langop_pallette2?></option>
				<option><?=$langop_pallette3?></option>
				<option><?=$langop_pallette4?></option>
				<option><?=$langop_pallette5?></option>
				<option><?=$langop_pallette6?></option>
				<option><?=$langop_pallette7?></option>
				<option><?=$langop_pallette8?></option>
				<option><?=$langop_pallette9?></option>
				<option><?=$langop_pallette10?></option>
				<option><?=$langop_pallette11?></option>
				<option><?=$langop_pallette12?></option>
				<option><?=$langop_pallette13?></option>
				<option><?=$langop_pallette14?></option>
			</select>
		</p>

		<p>
			<input class="submit" onclick="PaletteNew()" type="button" value="<?=$langop_savpallette?>" name="button" />
			<br />
			<input class="submit" onclick="PaletteRenew()" type="button" value="<?=$langop_savcolorcng?>" name="button" />
			<br />
			<input class="submit" onclick="PaletteDel()" type="button" value="<?=$langop_word_delete.$langop_word_Palette?>" name="button" />
			<br />
			<input class="submit" onclick="P_Effect(10)" type="button" value="<?=$langop_word_Brighten?>" name="button" />
			<br />
			<input class="submit" onclick="P_Effect(-10)" type="button" value="<?=$langop_word_Darken?>" name="button" />
			<br />
			<input class="submit" onclick="P_Effect(255)" type="button" value="<?=$langop_word_invert?>" name="button" />
			<br />
		</p>

		<h4><?=$langop_palletemini?></h4>

		<p>
			<select class="submit" name="m_m">
				<option value="0" selected="selected"><?=$langop_paletteopt1?></option>
				<option value="1"><?=$langop_paletteopt2?></option>
				<option value="2"><?=$langop_apppalette?></option>
			</select>
			<br />

			<input class="submit" onclick="PaletteMatrixGet()" type="button" value="<?=$langop_pallette_get?>" name="m_g" />
			<input class="submit" onclick="PalleteMatrixSet()" type="button" value="<?=$langop_pallette_set?>" name="m_s" />
			<br />

			<textarea class="multiline" name="setr" rows="3" cols="13"></textarea>
			<br />
		</p>
	</form>


	<form name="grad" action="post">
		<h4><?=$langop_word_Gradation?></h4>

		<p>
			<input class="submit" onclick="GetPalette();" type="button" value="<?=$langop_pallette_get?>" />
			<input class="submit" onclick="ChengeGrad();" type="button" value="<?=$langop_pallette_set?>" />
			<br />

			<select id="grad_start" class="ptxtinput" onchange="GetPalette();" name="p_st">
				<option selected="selected">1 &nbsp; &nbsp; &nbsp; &nbsp; </option>
				<option>2</option>
				<option>3</option>
				<option>4</option>
				<option>5</option>
				<option>6</option>
				<option>7</option>
				<option>8</option>
				<option>9</option>
				<option>10</option>
				<option>11</option>
				<option>12</option>
				<option>13</option>
				<option>14</option>
			</select>
			<input class="ptxtinput" size="8" name="pst" />
			<br />

			<select id="grad_end" class="ptxtinput" onchange="GetPalette();" name="p_ed">
				<option>1 &nbsp; &nbsp; &nbsp; &nbsp; </option>
				<option>2</option>
				<option>3</option>
				<option>4</option>
				<option>5</option>
				<option>6</option>
				<option>7</option>
				<option>8</option>
				<option>9</option>
				<option>10</option>
				<option>11</option>
				<option selected="selected">12</option>
				<option>13</option>
				<option>14</option>
			</select>
			<input class="ptxtinput" size="8" name="ped" />
			<br />
		</p>
	</form>
</td>
</tr>
</table>
<br />


<!-- Controls -->
<div class="pheader">
	<?=$langop_appcontrol?>
</div>

<table class="pinfotable" style="width: 100%; text-align: center;">
	<tr>
	<td style="width: 50%;">
		<p>
			<strong><?=$langop_plznote?>:</strong>
		</p>
		<ul>
			<li><?=$langop_canvchgdest?>!</li>
			<li><?=$langop_noresizeretou?></li>
			<li><?=$langop_refreshbret?></li>
			<li><?=$langop_float?></li>
			<li><?=$langop_pntscnregly?>! &nbsp;<code>;)</code></li>
		</ul>
	</td>

<? if (!$edit) { ?>
	<td style="width: 50%;">
		<form name="form1" method="get" action="noteBBS.php">
			<p>
				<?=$langop_applet_modify?>
				( <?=$langop_applet_max?> <?=$cfg['canvas_x']?> &times; <?=$cfg['canvas_y']?> )
			</p>

			<p>
				<?=$langop_canvasx?>: <input type="text" name="xcord" value="<?=$xcord?>" class="ptxtinput" /><br />
				<?=$langop_canvasy?>: <input type="text" name="ycord" value="<?=$ycord?>" class="ptxtinput" /><br />
			</p>
<? if ($anim) { ?>
			<input type="hidden" name="anim" value="<?=$anim?>" />
<? } ?>
			<input type="submit" name="Submit" value="<?=$langop_word_modify?>" class="submit" />
		</form>
	</td>
<? } ?>
	</tr>
</table>
<br />


<!-- Info -->
<div class="pheader">
	<?=$langop_javaimfo?> 
</div>

<div class="pinfotable">
	<p style="text-align: center; padding: 0 20% 0 20%;">
		<?=$langop_javahlp?> <a href="http://www.Java.com">www.Java.com</a>.  <?=$langop_javahlp2?> 
	</p>
</div>
<br />


</body>
</html>